##########################################################
### Import Necessary Modules

import argparse		               #provides options at the command line
import sys		               #take command line arguments and uses it in the script
import gzip		               #allows gzipped files to be read
import re		               #allows regular expressions to be used


##########################################################
### Command-line Arguments
parser = argparse.ArgumentParser(description="A script to convert from dss format to bismark format")
parser.add_argument("-file", help = "The location of the dss file(s), default=<stdin>, comma-separated for multiple files", nargs='+')
parser.add_argument("-frac", help = "The fraction of methylated C's at a position to be considered methylated (statistic only), default=0.5", default=0.5)
args = parser.parse_args()

#########################################################
### Global Variables
class Variables():
    positions = 0
    methylated = 0

#########################################################
### Opening files and functions
class OpenFile():
    def __init__ (self, f, inde):
        """Opens a file -- dss accepted"""
        if re.search(".dss.gz$", f):
            self.filename = gzip.open(f, 'rb')
            OpenDss(self.filename)
        elif re.search(".dss$", f):
            self.filename = open(filename, 'r')
            OpenDss(self.filename)

class OpenDss():
    def __init__ (self,f):
        """Opens dss file and returns information gathered"""
        self.header = f.readline()
        for self.line in f:
            self.line = self.line.rstrip('\n')
            self.seq, self.pos, self.coverage, self.methyl = self.line.split()[0:4]
            if int(self.coverage) > 0:
                self.fraction = round(int(self.methyl)/float(self.coverage),1)
                self.unmethylated = 0
                if int(self.coverage) > int(self.methyl):
                    self.unmethylated = int(self.coverage) - int(self.methyl)
                print "{}\t{}\t{}\t{}\t{}\t{}".format(self.seq, self.pos, self.pos, self.fraction, self.methyl, self.unmethylated )
                if float(self.fraction) > float(args.frac):
                    Variables.methylated += 1
                Variables.positions += 1
        f.close()
        sys.stderr.write("\tFound: {} potentially methylated positions (coverage not zero)\n".format(Variables.positions))
        sys.stderr.write("\tFound: {} that were methylated\n\n".format(Variables.methylated))

#########################################################
###Order of things to be called
if __name__ == '__main__':
    Variables()
    if len(args.file) > 0:
        for index, dssFile in enumerate(args.file):
            open_file = OpenFile(dssFile, index)

